% 6th order lowly damped, periodically time-varying system


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% poles 6th order LTI system %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% resonance angular frequencies in rad/s
w01 = 2*pi*80;
w02 = 2*pi*130;
w03 = 2*pi*200;

% damping ratios poles
zeta1 = 0.015;
zeta2 = 0.01;
zeta3 = 0.02;

% denominator transfer function
A = conv([1/w01^2 2*zeta1/w01 1], conv([1/w02^2 2*zeta2/w02 1],[1/w03^2 2*zeta3/w03 1]));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% zeroes 6th order LTI system %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% definition transmission zeroes in rad/s
wz1 = 2*pi*105;
wz2 = 2*pi*165;

% damping zeroes
zetaz1 = 0.001;
zetaz2 = 0.0008;

% numerator transfer function
B = conv([1/wz1^2 2*zetaz1/wz1 1],[1/wz2^2 2*zetaz2/wz2 1]);


%%%%%%%%%%%%%%%%%%%%%%%%%
% LTI transfer function %
%%%%%%%%%%%%%%%%%%%%%%%%%

freq = [50:0.1:250];
s = 2*pi*sqrt(-1)*freq;
G = polyval(B, s)./polyval(A, s);
%plot(freq, db(G)); shg


%%%%%%%%%%%%%%%%%%%%%%%%%
% LTI state space model %
%%%%%%%%%%%%%%%%%%%%%%%%%

[A0, B0, C0, D0] = tf2ss(B, A);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% LTV state space matrices %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%alpha = 0.1;
%beta = 0.2;
%gamma = 0.15;
alpha = [0.1; 0.2; 0.15;];
fT = 20;                % 1/fT is the period of the time variation

%A1 = A0 * alpha*sin(2*pi*fT*time);
%B1 = B0 * beta*sin(2*pi*fT*time);
%C1 = C0 * gamma*sin(2*pi*fT*time);
