clear all; ex = 'mathieu'; P = 3; Tp = 20; N = 7; 
s_vec = linspace(0, 0.5, N); test_pltv
clear all; ex = 'rand'; p = 1; n = 2; 
T = 1000; s = 1; N = 7; NN = 100;
PP = [5 10 15 20 50 100 200];

methods = [1 2 4 3]; 
lm = {'ro-' 'bx-' 'gs-' 'kd-'};
for ii = 1:N
  randn('seed', 0), rand('seed', 0) 
  P = PP(ii); Tp = ceil(T / P);
  switch lower(ex) 
    case {'mathieu','mathieu2'}, 
      n = 2; p = 1; thb = []; psi0 = eye(n);
      for tau = 1:P, 
        a(:, :, tau) = [0 1; ...
          -.9  -(0.1 + 0.4 * cos(2 * pi / P * tau))]; 
        c(:, :, tau) = [1 0]; 
        thb = [thb; a(end, :, tau)']; 
        psi0 = psi0 * a(:, :, tau);
      end
      th0 = poly(eig(psi0));
    case 'rand', 
      w = rand(1, floor(n / 2)); 
      if mod(n, 2) ~= 0, w = [w 0]; end
      phi = assign_eig(exp(sqrt(-1) * pi * w)); thb = NaN;
      t = (1:P)'; psi = cos(kron((1:p)', t) * (1:n) * pi);
      for i = 1:P
        a(:, :, i) = eye(n); 
        c(:, :, i) = psi((i - 1) * p + 1: i * p, :); 
      end
      a(:, :, P) = phi;
  end
  T = P * Tp; Tid = round(3 / 4 * T); 
  sys0 = struct('a', a, 'c', c); 
  x0 = rand(n, 1); [y0, X0] = pltv_sim(sys0, T, x0); 
  for jj = 1:NN
    yt = randn(size(y0)); 
    y = y0 + s * norm(y0, 'fro') * yt / norm(yt, 'fro'); 
    for k = 1:length(methods)
      m = methods(k);
      str = sprintf(['[sysh, xhini] = ' ...
            'pltv_ident%d(y(1:Tid), P, n);'], m);         
      try  
        eval(['tic, ' str 'time(k, ii, jj) = toc;'])
        E(k, ii, jj) = norm(poly(eig(sys0.a(:,:,end))) - ...
                            poly(eig(sysh.a(:,:,end)))) / ...
                       norm(poly(eig(sys0.a(:,:,end)))); 
      catch
        time(k, ii, jj) = NaN; E(k, ii, jj) = NaN; 
      end
    end
  end
end  

l{1} = 'P'; 
for k = 1:length(methods) 
  l = [l; ['Alg. ' int2str(k)]]; 
end
res = [l num2cell([PP; mean(time, 3)])]; 
!rm time, diary('time'), 
disp(res), pause(.1), diary off
res = [l num2cell([PP; mean(E, 3)])]; 
!rm error, diary('error'), 
disp(res), pause(.1), diary off
clear all; ex = 'mathieu'; P = 3; Tp = 20; N = 7; s = 0.5; NN = 100;
f_missing = linspace(0, 0.3, N); 

randn('seed', 0), rand('seed', 0) 
switch lower(ex) 
  case {'mathieu','mathieu2'}, 
    n = 2; p = 1; thb = []; psi0 = eye(n);
    for tau = 1:P, 
      a(:, :, tau) = [0 1; ...
        -.9  -(0.1 + 0.4 * cos(2 * pi / P * tau))]; 
      c(:, :, tau) = [1 0]; 
      thb = [thb; a(end, :, tau)']; 
      psi0 = psi0 * a(:, :, tau);
    end
    th0 = poly(eig(psi0));
  case 'rand', 
    w = rand(1, floor(n / 2)); 
    if mod(n, 2) ~= 0, w = [w 0]; end
    phi = assign_eig(exp(sqrt(-1) * pi * w)); thb = NaN;
    t = (1:P)'; psi = cos(kron((1:p)', t) * (1:n) * pi);
    for i = 1:P
      a(:, :, i) = eye(n); 
      c(:, :, i) = psi((i - 1) * p + 1: i * p, :); 
    end
    a(:, :, P) = phi;
end
T = P * Tp; Tid = round(3 / 4 * T); 
sys0 = struct('a', a, 'c', c); 
x0 = rand(n, 1); [y0, X0] = pltv_sim(sys0, T, x0); 
yt = randn(size(y0)); 
y = y0 + s * norm(y0, 'fro') * yt / norm(yt, 'fro'); 

methods = 4; 
for ii = 1:N
  for jj = 1:NN
    Im = randperm(T); Tm = round(f_missing(ii) * T);
    ym = y; ym(Im(1:Tm)) = NaN;
    [sysh, xhini] = pltv_ident3(ym, P, n);
    E(1, ii, jj) = norm(th0 - poly(eig(sysh.a(:,:,end))) / norm(th0)); 
  end
end  
l{1} = 'FM'; 
for k = 1:length(methods) 
  l = [l; ['Alg. ' int2str(k)]]; 
end
res = [l num2cell([f_missing; mean(E, 3)])]; 
!rm error-missing, diary('error-missing'), 
disp(res), pause(.1), diary off
