clear all; ex = 'rand'; T = 5000; 
p = 1; n = 2; s = 0.1; P = 100;
NN = 10; TT = round(linspace(1000, T, NN)); K = 100;
Tp = ceil(T / P); fid = 1;
switch lower(ex) 
  case {'mathieu','mathieu2'}, 
    n = 2; p = 1; 
    thb = []; phi0 = eye(n);
    for tau = 1:P, 
      a(:, :, tau) = [0 1; ...
        -.9  -(0.1 + 0.4 * cos(2 * pi / P * tau))]; 
      c(:, :, tau) = [1 0]; 
      thb = [thb; a(end, :, tau)']; 
      phi0 = phi0 * a(:, :, tau);
    end
    th0 = poly(eig(phi0));
  case 'rand', 
    w = rand(1, floor(n / 2)); 
    if mod(n, 2) ~= 0, w = [w 0]; end
    phi = assign_eig(exp(sqrt(-1) * pi * w)); thb = NaN;
    psi = rand(p * P, n); 
    for i = 1:P
      a(:, :, i) = eye(n); 
      c(:, :, i) = psi((i - 1) * p + 1: i * p, :); 
    end
    a(:, :, P) = phi;
end
T = P * Tp; Tid = round(fid * T); 
sys0 = struct('a', a, 'c', c); 
x0 = rand(n, 1); [y0, X0] = pltv_sim(sys0, T, x0); 
th0 = poly(eig(sys0.a(:,:,end)))';

methods = 4; lm = {'ro-' 'bx-' 'gs-' 'kd-'};
for ii = 1:NN
  randn('seed', 0), rand('seed', 0) 
  T = TT(ii); Tp = ceil(T / P);
  for jj = 1:K
    yt = randn(size(y0)); 
    y = y0 + s * norm(y0, 'fro') * yt / norm(yt, 'fro'); 
    for k = 1:length(methods)
      m = methods(k);
      str = sprintf(['[sysh, xhini] = ' ...
            'pltv_ident%d(y(1:T), P, n);'], m);   
      try  
        eval(str); th(:, jj) = poly(eig(sysh.a(:,:,end)))';
        E(k, ii, jj) = norm(th0 - th(:, jj)) / norm(th0); 
      catch
        E(k, ii, jj) = NaN; 
      end
    end
  end
end  

Em  = mean(E, 3); Emh = 1 ./ sqrt(TT); al = Em(1, :) / Emh; 
figure(1), plot(TT, Em(1, :), '-k') %, TT, al * Emh, ':b'); 
ax = axis; axis([TT(1) TT(end) ax(3:4)]), 
% legend('empirical      .') % , 'theoretical'), 
print_fig('consistency')

[sysh, xhini, ~, ~, info] = pltv_ident4(y(1:T), P, n);
c = chi2inv(0.95, n); vh = info.fmin / T; Vh = vh * info.Vh; 
figure(2), ellipsoid(sqrtm(c * Vh), th0(2:3), 'g'), hold on
plot(th0(2), th0(3), 'rX', 'markersize', 10)
for i = 1:K, plot(th(2, i), th(3, i), 'b.', 'markersize', 10), end
print_fig('err-bounds')
