clear all, ex = 'rand'; p = 1; n = 5; 
T = 10000; s = 0.1; NN = 100; fid = 1;
PP = [10 100 200 500 750 1000]; N = length(PP); 

methods = [1 2 3]; 
lm = {'ro-' 'bx-' 'gs-' 'kd-'};
for ii = 1:N
  randn('seed', 0), rand('seed', 0) 
  P = PP(ii); Tp = ceil(T / P);
  switch lower(ex) 
    case {'mathieu','mathieu2'}, 
      n = 2; p = 1; 
      thb = []; phi0 = eye(n);
      for tau = 1:P, 
        a(:, :, tau) = [0 1; ...
          -.9  -(0.1 + 0.4 * cos(2 * pi / P * tau))]; 
        c(:, :, tau) = [1 0]; 
        thb = [thb; a(end, :, tau)']; 
        phi0 = phi0 * a(:, :, tau);
      end
      th0 = poly(eig(phi0));
    case 'rand', 
      w = rand(1, floor(n / 2)); 
      if mod(n, 2) ~= 0, w = [w 0]; end
      phi = assign_eig(exp(sqrt(-1) * pi * w)); thb = NaN;
      psi = rand(p * P, n); 
      for i = 1:P
        a(:, :, i) = eye(n); 
        c(:, :, i) = psi((i - 1) * p + 1: i * p, :); 
      end
      a(:, :, P) = phi;
  end
  T = P * Tp; Tid = round(fid * T); 
  sys0 = struct('a', a, 'c', c); 
  x0 = rand(n, 1); [y0, X0] = pltv_sim(sys0, T, x0); 
  phi0 = sys0.a(:,:,end);
  for jj = 1:NN
    yt = randn(size(y0)); 
    y = y0 + s * norm(y0, 'fro') * yt / norm(yt, 'fro'); 
    for k = 1:length(methods)
      m = methods(k);
      str = sprintf(['[sysh, xhini, t] = ' ...
            'pltv_ident%d(y(1:Tid), P, n);'], m);         
      %try  
        eval(str),  time(k, ii, jj) = t;
        if methods(k) == 1
          phih = eye(n);
          for ll = 1:P
            phih = sysh.a(:,:,ll) * phih;
          end
        else
          phih = sysh.a(:,:,end);
        end
        E(k, ii, jj) = norm(poly(eig(phi0)) - ...
                            poly(eig(phih))) / ...
                       norm(poly(eig(phi0))); 
      %catch
      %  time(k, ii, jj) = NaN; E(k, ii, jj) = NaN; 
      %end
    end
  end
end  
for k = 1:length(methods) 
  rl{k} = ['Alg. ' int2str(methods(k))]; 
end
cl = cellstr(num2str(PP'));
disp([['P'; rl'] num2cell([PP; mean(time, 3)])])
matrix2latex(mean(time, 3), 'time', 'rowLabels', rl, 'columnLabels', cl, 'format', '%-6.4f')
disp([['P'; rl'] num2cell([PP; mean(E,    3)])]) 
matrix2latex(mean(E, 3), 'error', 'rowLabels', rl, 'columnLabels', cl, 'format', '%-6.4f')
