randn('seed', 0), rand('seed', 0) 
switch lower(ex) 
  case {'mathieu','mathieu2'}, 
    n = 2; p = 1; 
    thb = []; phi0 = eye(n);
    for tau = 1:P, 
      a(:, :, tau) = [0 1; ...
        -.9  -(0.1 + 0.4 * cos(2 * pi / P * tau))]; 
      c(:, :, tau) = [1 0]; 
      thb = [thb; a(end, :, tau)']; 
      phi0 = phi0 * a(:, :, tau);
    end
    th0 = poly(eig(phi0));
  case 'rand', 
    w = rand(1, floor(n / 2)); 
    if mod(n, 2) ~= 0, w = [w 0]; end
    phi = assign_eig(exp(sqrt(-1) * pi * w)); thb = NaN;
    psi = rand(p * P, n); 
    for i = 1:P
      a(:, :, i) = eye(n); 
      c(:, :, i) = psi((i - 1) * p + 1: i * p, :); 
    end
    a(:, :, P) = phi;
end
T = P * Tp; Tid = round(fid * T); 
sys0 = struct('a', a, 'c', c); 
x0 = rand(n, 1); [y0, X0] = pltv_sim(sys0, T, x0); , 
methods = [1 2 3 4]; 
lm = {'ro-' 'bx-' 'gs-' 'kd-'}; 
for i = 1:N
  s = s_vec(i); 
  for j = 1:NN
    yt = randn(size(y0)); 
    y = y0 + s * norm(y0, 'fro') * yt / norm(yt, 'fro'); 
    for k = 1:length(methods)
      m = methods(k);
      str = sprintf(['[sysh, xhini] = ' ...
            'pltv_ident%d(y(1:Tid), P, n);'], m);
      eval(['tic, ' str 't(k, i, j) = toc;']) 
      yh = pltv_sim(sysh, T, xhini); 
      e = norm(y0(Tid + 1:end) - ...
               yh(Tid + 1:end), 'fro') / ...
          norm(y0(Tid + 1:end) - ...
               mean(y0(Tid + 1:end)), 'fro');, E(k, i, j) = e; Yh(:, k, i, j) = yh;
    end
  end
end
for k = 1:length(methods) 
  rl{k} = ['Alg. ' int2str(methods(k))]; 
end
disp([['SNR'; rl'] num2cell([1 ./ s_vec; mean(E, 3)])])
cl = cellstr(num2str(1 ./ s_vec'));
matrix2latex(mean(E, 3), 'mathieu', 'rowLabels', rl, 'columnLabels', cl, 'format', '%-6.4f')
figure(1), clf, 
plot(y0, '-k'), hold on, plot(y, 'k:') 
for k = 1:length(methods) 
  plot(Yh(:, k, end, 1), lm{k}) 
end
l = {}; 
for k = 1:length(methods) 
  l = [l; ['yh' int2str(k)]]; 
end
legend('true data', 'noisy data', l{1:end})
axis([1 60 -0.3 0.5])
print_fig([ex '-f1'])

for k = 1:length(methods)
  figure(k + 1), clf, hold on, 
  plot(abs(y0 - mean(Yh(:, k, end, :), 4)), '-')
  plot(std(Yh(:, k, end, :), [], 4), '--')
  l = {sprintf('|y0 - mean(yh%s)|   .', int2str(k)); 
       sprintf('std(yh%s)', int2str(k))};
  legend(l)
  ax(k, :) = axis;
end
for k = 1:length(methods)
  figure(k + 1), axis([1 T 0 max(ax(:, 4))])  
  print_fig([ex '-f' int2str(k + 1)])
end
