clear all, close all
PTVdynamics
global A0 C0 alpha fT

xini = [1 0 0 0 0 0]'; 
ts = 1e-3; t = 0:ts:0.6; s = 0.25;

odeset.RelTol = 1e-10;
odeset.AbsTol = eps;
odeset.InitialStep = ts/10;
odeset.MaxStep = ts;
[t, x0] = ode45('fun', t, xini, odeset); y0 = x2y(t, x0);
yt = randn(size(y0)); y = y0 + s * yt / norm(yt) * norm(y0);
figure(1), plot(t, y0, 'k--'), hold on, plot(t, y, 'b:') 
ax = axis; axis([0 t(end) ax(3:4)])

P = 1/fT / ts; n = 6; T = length(t);

[sysh, xhini] = pltv_ident3(y', P, n);
[yh, xh] = pltv_sim(sysh, T, xhini);
plot(t, yh, 'r-.'), print_fig('new')
axis([0.4 t(end) 1/4 * ax(3:4)]), print_fig('new-zoom')

e = norm(y' - yh) / norm(y)

return

[sysh, xhini] = pltv_ident4(y', P, n);
[yh, xh] = pltv_sim(sysh, T, xhini);
plot(t, yh, 'r--')
e = norm(y' - yh) / norm(y)
